//
// Procedures and functions
//

program Demo1;

function Fact( N : Integer ) : Integer; forward; // forward declaration

procedure Hanoi( N : Integer; X, Y, Z : Char );
begin
  if N > 0 then
  begin
    Hanoi( N - 1, X, Z, Y );
    writeln( 'Move ' + X + ' to ' + Y );
    Hanoi( N - 1, Z, Y, X );
  end;
end;

function Fact( N : Integer ) : Integer;
begin
  if N < 2 then
    result := 1
  else
    result := N * Fact( N - 1 );
end;

procedure Swap( var X, Y : Integer );
var
  temp : Integer;
begin
  temp := X;
  X := Y;
  Y := temp;
end;

procedure A;
var
  Z : Real;
procedure Inner;
begin
  writeln( Z );
end;
begin
  Z := 3.14;
  Inner;
  Z := 2.7;
  Inner;
end;

var
  X, Y : Integer;
  S : String;
begin
  X := 10;
  Y := 20;
  Swap( X, Y );
  writeln( X );
  writeln( Y );
  writeln( Fact( 5 ) );
  Hanoi( 3, 'A', 'B', 'C' );
  A;
  X := SizeOf( Y );  // standard function call
  writeln( X );
  S := IntToStr( Y );
  writeln( S );

  S := Copy( 'abcdefgh', 3, 2 ); 
  writeln( S );

  _Print( 's.txt', 'p.txt' ); // print the p-code state
end.
